library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;

entity Provera_skidanje_zaglavlja is
	Port 
	( 
		clk		: in   STD_LOGIC;
		reset		: in	 STD_LOGIC;
		start		: in   STD_LOGIC;
		kraj		: in   STD_LOGIC;
		data_in	: in   STD_LOGIC_VECTOR (127 downto 0);
		start_out: out  STD_LOGIC;
		kraj_out : out STD_LOGIC;
		data_out	: out  STD_LOGIC_VECTOR (127 downto 0)
	);
end Provera_skidanje_zaglavlja;

architecture shema of Provera_skidanje_zaglavlja is

signal i:integer; 

begin

	process (clk,data_in, start, kraj, reset)
	
		variable zaglavlje:std_logic_vector (159 downto 0):= (others => '0');
		variable zaglavlje2:std_logic_vector (127 downto 0):= (others => '0'); -- koristim zbog potrebe citanja samo drugog dela zaglavlja koji ima 32 bita
		variable total_length:integer;
		variable zbir:std_logic_vector (19 downto 0) := (others => '0');--za proveru checksume
		variable novi_zbir:std_logic_vector (15 downto 0):= (others => '0');--za proveru checksume
	begin
		
		if(reset='1') then
			i<=0;
			start_out<='0';
			kraj_out<='0';
		else
		
			if(clk' event and clk='1') then
					start_out<='0';
					kraj_out<='0';		
				if(start='1') then
					zaglavlje(159 downto 32):=data_in;
					i<=1;						
				end if;
			
				if(i=1) then
					zaglavlje2:=data_in;
					zaglavlje(31 downto 0):=zaglavlje2(127 downto 96);
					i<=2;
				end if;
			
				if(i=2) then
					if (zaglavlje(159 downto 156)="0100") then
						if( zaglavlje(95 downto 88)/="00000000") then
							total_length:=conv_integer(zaglavlje(143 downto 128));--podatak koji nam govori kolika je duzina paketa
							total_length:=total_length-32;
							--provera checksume a samim tim i provera zaglavlja
							zbir:=("0000" & zaglavlje(159 downto 144))+zaglavlje(143 downto 128)+zaglavlje(127 downto 112)+zaglavlje(111 downto 96)+zaglavlje(95 downto 80)+zaglavlje(79 downto 64)+zaglavlje(63 downto 48)+zaglavlje(47 downto 32)+zaglavlje(31 downto 16)+zaglavlje(15 downto 0);
							novi_zbir:=zbir(15 downto 0)+zbir(19 downto 16);
							if(novi_zbir=x"ffff") then
								if(kraj='1') then -- ako je izlaz jednak 1 to znacai da imamo samo jedan paket
									data_out<=data_in;
						
									kraj_out<='1';
									start_out<='1';
		
									i<=0;
								else  -- ako nije jednak 1 onda se vrsi proseldjivanje paketa na izlaz i prolazak kroz dalji deo programa
									data_out<=data_in;
									
									start_out<='1';
																	
									i<=3;
								
									total_length:=total_length-16;
								
								end if; -- kraj
							else
								i<=0;--kada zaglavlje nije dobro ne salje se nista na izlaz i postavaljamo i=0
							end if;-- novi zbir
						end if;--da li je TTL polje razlicito od 0
					end if;-- da li je verzija IPv4
				end if;-- kada je i=2
			
				if(i=3) then
					if(total_length>0) then
						if(kraj='1') then
							data_out<=data_in;
					
							kraj_out<='1';
								
							total_length:=0;
					
							i<=0;
						else 
							data_out<=data_in;
					
							total_length:=total_length-16;
						end if;
					end if;
				end if;--kada je i>=3
			end if;--clk
		end if; --reset
	end process;

end shema;

