library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity mix_kolona is
	Port
	( 
		in_mix_kolona  : in   STD_LOGIC_VECTOR (127 downto 0);
		out_mix_kolona : out  STD_LOGIC_VECTOR (127 downto 0)
	);
end mix_kolona;

architecture shema of mix_kolona is

procedure mix_kolona2 (variable in_mix_kolona:in STD_LOGIC_VECTOR(31 downto 0);variable out_mix_kolona:out STD_LOGIC_VECTOR(31 downto 0)) IS--ulazni argument je duzine cetiri bajta(jedna kolona)(bajtovi B1,B2,B3 i B4)
	variable B1,B2,B3,B4,B1new,B2new,B3new,B4new: STD_LOGIC_VECTOR (7 DOWNTO 0);
	variable x11, x12,x13,x14,x21,x22,x23,x24: STD_LOGIC_VECTOR (7 DOWNTO 0);
	
	
BEGIN
	
	
	B1:=in_mix_kolona(31 downto 24);
	B2:=in_mix_kolona(23 downto 16);
	B3:=in_mix_kolona(15 downto 8);
	B4:=in_mix_kolona(7 downto 0);

	if (B1(7)='0') then 
		x11:=B1(6 downto 0)&'0'; -- racun za 2
		x21:=((B1(6 downto 0))&'0') xor B1; -- racun za 3 
	else 
		x11:=(B1(6 downto 0)&'0') xor "00011011"; -- racun za 2
		x21:=((B1(6 downto 0)&'0') xor "00011011") xor B1; -- racun za 3
	end if;
	
	if (B2(7)='0') then 
		x12:=B2(6 downto 0)&'0';
		x22:=((B2(6 downto 0))&'0') xor B2;
	else 
		x12:=(B2(6 downto 0)&'0') xor "00011011";
		x22:=((B2(6 downto 0)&'0') xor "00011011") xor B2;
	end if;
	
	if (B3(7)='0') then 
		x13:=B3(6 downto 0)&'0';
		x23:=((B3(6 downto 0))&'0') xor B3; 
	else 
		x13:=(B3(6 downto 0)&'0') xor "00011011";
		x23:=((B3(6 downto 0)&'0') xor "00011011") xor B3;
	end if;

	if (B4(7)='0') then 
		x14:=B4(6 downto 0)&'0';
		x24:=((B4(6 downto 0))&'0') xor B4;
	else 
		x14:=(B4(6 downto 0)&'0') xor "00011011";
		x24:=((B4(6 downto 0)&'0') xor "00011011") xor B4;
	end if;
	
	B1new:=x11 xor x22 xor B3 xor B4;
	B2new:=B1 xor x12 xor x23 xor B4;
	B3new:=B1 xor B2 xor x13 xor x24;
	B4new:=x21 xor B2 xor B3 xor x14;
	
	out_mix_kolona(31 downto 24):=B1new;
	out_mix_kolona(23 downto 16):=B2new;
	out_mix_kolona(15 downto 8):=B3new;
	out_mix_kolona(7 downto 0):=B4new;
	
	
END mix_kolona2;

begin

	process(in_mix_kolona)
	
	variable data_in2, data_out2 : std_logic_vector (127 downto 0):=(others => '0');
	
	begin
		
		data_in2:=in_mix_kolona;
		
		mix_kolona2(data_in2(31 downto 0),data_out2(31 downto 0));
		mix_kolona2(data_in2(63 downto 32),data_out2(63 downto 32));
		mix_kolona2(data_in2(95 downto 64),data_out2(95 downto 64));
		mix_kolona2(data_in2(127 downto 96),data_out2(127 downto 96));
		
		out_mix_kolona<=data_out2;
	
	end process;

end shema;

