library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity prva_runda_Rx is
	port
	(
		data_in:		in  STD_LOGIC_VECTOR (127 downto 0);
		kljuc_in:	in  STD_LOGIC_VECTOR (127 downto 0);
		data_out:	out  STD_LOGIC_VECTOR (127 downto 0)
	);
end prva_runda_Rx;

architecture shema of prva_runda_Rx is

	component inv_sbox2 is
		Port
		(
			in_sbox  : in   STD_LOGIC_VECTOR (127 downto 0);
			out_sbox : out  STD_LOGIC_VECTOR (127 downto 0)
		);
	end component;

	component inv_shift_rows is
		Port
		(
			in_shift_rows 	: in   STD_LOGIC_VECTOR (127 downto 0);
			out_shift_rows : out  STD_LOGIC_VECTOR (127 downto 0)
		);
	end component;

	component inv_add_round_key is
		Port
		(
			data_in  : in   STD_LOGIC_VECTOR (127 downto 0);
			kljuc_in : in   STD_LOGIC_VECTOR (127 downto 0);
			data_out : out  STD_LOGIC_VECTOR (127 downto 0)
		);
	end component;
	
	signal 	data1,data2  :   STD_LOGIC_VECTOR (127 downto 0);
begin


	add_key_inst: inv_add_round_key 
		Port map
		(
			data_in  => data_in,
			kljuc_in => kljuc_in,
			data_out =>data1
		);
			
		
	inv_shift_inst: inv_shift_rows 
		Port map
		(
			in_shift_rows 	=> data1,
			out_shift_rows => data2
		);	

	inv_sbox_inst: inv_sbox2 
		Port map
		(
			in_sbox  => data2,
			out_sbox => data_out
		);		

end shema;

