library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_SIGNED.ALL;

entity razvijanje_kljuca is
	Port 
	( 
		clk 			: in  STD_LOGIC;
		kljuc 		: in  STD_LOGIC_VECTOR (127 downto 0);
      kljuc0_out 	: out STD_LOGIC_VECTOR (127 downto 0);
      kljuc1_out	: out STD_LOGIC_VECTOR (127 downto 0);
      kljuc2_out 	: out STD_LOGIC_VECTOR (127 downto 0);
      kljuc3_out 	: out STD_LOGIC_VECTOR (127 downto 0);
      kljuc4_out 	: out STD_LOGIC_VECTOR (127 downto 0);
      kljuc5_out 	: out STD_LOGIC_VECTOR (127 downto 0);
      kljuc6_out 	: out STD_LOGIC_VECTOR (127 downto 0);
      kljuc7_out 	: out STD_LOGIC_VECTOR (127 downto 0);
      kljuc8_out 	: out STD_LOGIC_VECTOR (127 downto 0);
      kljuc9_out 	: out STD_LOGIC_VECTOR (127 downto 0);
      kljuc10_out : out STD_LOGIC_VECTOR (127 downto 0)
	);
	
end razvijanje_kljuca;



architecture shema of razvijanje_kljuca is

--signal za potrebe pomeranja kljuceva tacnije da bi se svaka runda posebno implementirala u hardveru
signal kljuc1:std_logic_vector(127 downto 0):= (others => '0');
signal kljuc2:std_logic_vector(127 downto 0):= (others => '0');
signal kljuc3:std_logic_vector(127 downto 0):= (others => '0');
signal kljuc4:std_logic_vector(127 downto 0):= (others => '0');
signal kljuc5:std_logic_vector(127 downto 0):= (others => '0');
signal kljuc6:std_logic_vector(127 downto 0):= (others => '0');
signal kljuc7:std_logic_vector(127 downto 0):= (others => '0');
signal kljuc8:std_logic_vector(127 downto 0):= (others => '0');
signal kljuc9:std_logic_vector(127 downto 0):= (others => '0');
signal kljuc10:std_logic_vector(127 downto 0):= (others => '0');

-- funkicija sbox koja se koristi prilikom razvijanja kljuca
procedure sbox (variable in_sbox:in STD_LOGIC_VECTOR(7 downto 0);variable out_sbox:out std_logic_vector (7 downto 0)) is

BEGIN
	CASE (in_sbox) IS
		WHEN (x"00") => out_sbox:=x"63" ;
		WHEN (x"01") => out_sbox:=x"7c" ;
		WHEN (x"02") => out_sbox:=x"77" ;
		WHEN (x"03") => out_sbox:=x"7b" ;
		WHEN (x"04") => out_sbox:=x"f2" ;
		WHEN (x"05") => out_sbox:=x"6b" ;
		WHEN (x"06") => out_sbox:=x"6f" ;
		WHEN (x"07") => out_sbox:=x"c5" ;
		WHEN (x"08") => out_sbox:=x"30" ;
		WHEN (x"09") => out_sbox:=x"01" ;
		WHEN (x"0a") => out_sbox:=x"67" ;
		WHEN (x"0b") => out_sbox:=x"2b" ;
		WHEN (x"0c") => out_sbox:=x"fe" ;
		WHEN (x"0d") => out_sbox:=x"d7" ;
		WHEN (x"0e") => out_sbox:=x"ab" ;
		WHEN (x"0f") => out_sbox:=x"76" ;
		WHEN (x"10") => out_sbox:=x"ca" ;
		WHEN (x"11") => out_sbox:=x"82" ;
		WHEN (x"12") => out_sbox:=x"c9" ;
		WHEN (x"13") => out_sbox:=x"7d" ;
		WHEN (x"14") => out_sbox:=x"fa" ;
		WHEN (x"15") => out_sbox:=x"59" ;
		WHEN (x"16") => out_sbox:=x"47" ;
		WHEN (x"17") => out_sbox:=x"f0" ;
		WHEN (x"18") => out_sbox:=x"ad" ;
		WHEN (x"19") => out_sbox:=x"d4" ;
		WHEN (x"1a") => out_sbox:=x"a2" ;
		WHEN (x"1b") => out_sbox:=x"af" ;
		WHEN (x"1c") => out_sbox:=x"9c" ;
		WHEN (x"1d") => out_sbox:=x"a4" ;
		WHEN (x"1e") => out_sbox:=x"72" ;
		WHEN (x"1f") => out_sbox:=x"c0" ;
		WHEN (x"20") => out_sbox:=x"b7" ;
		WHEN (x"21") => out_sbox:=x"fd" ;
		WHEN (x"22") => out_sbox:=x"93" ;
		WHEN (x"23") => out_sbox:=x"26" ;
		WHEN (x"24") => out_sbox:=x"36" ;
		WHEN (x"25") => out_sbox:=x"3f" ;
		WHEN (x"26") => out_sbox:=x"f7" ;
		WHEN (x"27") => out_sbox:=x"cc" ;
		WHEN (x"28") => out_sbox:=x"34" ;
		WHEN (x"29") => out_sbox:=x"a5" ;
		WHEN (x"2a") => out_sbox:=x"e5" ;
		WHEN (x"2b") => out_sbox:=x"f1" ;
		WHEN (x"2c") => out_sbox:=x"71" ;
		WHEN (x"2d") => out_sbox:=x"d8" ;
		WHEN (x"2e") => out_sbox:=x"31" ;
		WHEN (x"2f") => out_sbox:=x"15" ;
		WHEN (x"30") => out_sbox:=x"04" ;
		WHEN (x"31") => out_sbox:=x"c7" ;
		WHEN (x"32") => out_sbox:=x"23" ;
		WHEN (x"33") => out_sbox:=x"c3" ;
		WHEN (x"34") => out_sbox:=x"18" ;
		WHEN (x"35") => out_sbox:=x"96" ;
		WHEN (x"36") => out_sbox:=x"05" ;
		WHEN (x"37") => out_sbox:=x"9a" ;
		WHEN (x"38") => out_sbox:=x"07" ;
		WHEN (x"39") => out_sbox:=x"12" ;
		WHEN (x"3a") => out_sbox:=x"80" ;
		WHEN (x"3b") => out_sbox:=x"e2" ;
		WHEN (x"3c") => out_sbox:=x"eb" ;
		WHEN (x"3d") => out_sbox:=x"27" ;
		WHEN (x"3e") => out_sbox:=x"b2" ;
		WHEN (x"3f") => out_sbox:=x"75" ;
		WHEN (x"40") => out_sbox:=x"09" ;
		WHEN (x"41") => out_sbox:=x"83" ;
		WHEN (x"42") => out_sbox:=x"2c" ;
		WHEN (x"43") => out_sbox:=x"1a" ;
		WHEN (x"44") => out_sbox:=x"1b" ;
		WHEN (x"45") => out_sbox:=x"6e" ;
		WHEN (x"46") => out_sbox:=x"5a" ;
		WHEN (x"47") => out_sbox:=x"a0" ;
		WHEN (x"48") => out_sbox:=x"52" ;
		WHEN (x"49") => out_sbox:=x"3b" ;
		WHEN (x"4a") => out_sbox:=x"d6" ;
		WHEN (x"4b") => out_sbox:=x"b3" ;
		WHEN (x"4c") => out_sbox:=x"29" ;
		WHEN (x"4d") => out_sbox:=x"e3" ;
		WHEN (x"4e") => out_sbox:=x"2f" ;
		WHEN (x"4f") => out_sbox:=x"84" ;
		WHEN (x"50") => out_sbox:=x"53" ;
		WHEN (x"51") => out_sbox:=x"d1" ;
		WHEN (x"52") => out_sbox:=x"00" ;
		WHEN (x"53") => out_sbox:=x"ed" ;
		WHEN (x"54") => out_sbox:=x"20" ;
		WHEN (x"55") => out_sbox:=x"fc" ;
		WHEN (x"56") => out_sbox:=x"b1" ;
		WHEN (x"57") => out_sbox:=x"5b" ;
		WHEN (x"58") => out_sbox:=x"6a" ;
		WHEN (x"59") => out_sbox:=x"cb" ;
		WHEN (x"5a") => out_sbox:=x"be" ;
		WHEN (x"5b") => out_sbox:=x"39" ;
		WHEN (x"5c") => out_sbox:=x"4a" ;
		WHEN (x"5d") => out_sbox:=x"4c" ;
		WHEN (x"5e") => out_sbox:=x"58" ;
		WHEN (x"5f") => out_sbox:=x"cf" ;
		WHEN (x"60") => out_sbox:=x"d0" ;
		WHEN (x"61") => out_sbox:=x"ef" ;
		WHEN (x"62") => out_sbox:=x"aa" ;
		WHEN (x"63") => out_sbox:=x"fb" ;
		WHEN (x"64") => out_sbox:=x"43" ;
		WHEN (x"65") => out_sbox:=x"4d" ;
		WHEN (x"66") => out_sbox:=x"33" ;
		WHEN (x"67") => out_sbox:=x"85" ;
		WHEN (x"68") => out_sbox:=x"45" ;
		WHEN (x"69") => out_sbox:=x"f9" ;
		WHEN (x"6a") => out_sbox:=x"02" ;
		WHEN (x"6b") => out_sbox:=x"7f" ;
		WHEN (x"6c") => out_sbox:=x"50" ;
		WHEN (x"6d") => out_sbox:=x"3c" ;
		WHEN (x"6e") => out_sbox:=x"9f" ;
		WHEN (x"6f") => out_sbox:=x"a8" ;
		WHEN (x"70") => out_sbox:=x"51" ;
		WHEN (x"71") => out_sbox:=x"a3" ;
		WHEN (x"72") => out_sbox:=x"40" ;
		WHEN (x"73") => out_sbox:=x"8f" ;
		WHEN (x"74") => out_sbox:=x"92" ;
		WHEN (x"75") => out_sbox:=x"9d" ;
		WHEN (x"76") => out_sbox:=x"38" ;
		WHEN (x"77") => out_sbox:=x"f5" ;
		WHEN (x"78") => out_sbox:=x"bc" ;
		WHEN (x"79") => out_sbox:=x"b6" ;
		WHEN (x"7a") => out_sbox:=x"da" ;
		WHEN (x"7b") => out_sbox:=x"21" ;
		WHEN (x"7c") => out_sbox:=x"10" ;
		WHEN (x"7d") => out_sbox:=x"ff" ;
		WHEN (x"7e") => out_sbox:=x"f3" ;
		WHEN (x"7f") => out_sbox:=x"d2" ;
		WHEN (x"80") => out_sbox:=x"cd" ;
		WHEN (x"81") => out_sbox:=x"0c" ;
		WHEN (x"82") => out_sbox:=x"13" ;
		WHEN (x"83") => out_sbox:=x"ec" ;
		WHEN (x"84") => out_sbox:=x"5f" ;
		WHEN (x"85") => out_sbox:=x"97" ;
		WHEN (x"86") => out_sbox:=x"44" ;
		WHEN (x"87") => out_sbox:=x"17" ;
		WHEN (x"88") => out_sbox:=x"c4" ;
		WHEN (x"89") => out_sbox:=x"a7" ;
		WHEN (x"8a") => out_sbox:=x"7e" ;
		WHEN (x"8b") => out_sbox:=x"3d" ;
		WHEN (x"8c") => out_sbox:=x"64" ;
		WHEN (x"8d") => out_sbox:=x"5d" ;
		WHEN (x"8e") => out_sbox:=x"19" ;
		WHEN (x"8f") => out_sbox:=x"73" ;
		WHEN (x"90") => out_sbox:=x"60" ;
		WHEN (x"91") => out_sbox:=x"81" ;
		WHEN (x"92") => out_sbox:=x"4f" ;
		WHEN (x"93") => out_sbox:=x"dc" ;
		WHEN (x"94") => out_sbox:=x"22" ;
		WHEN (x"95") => out_sbox:=x"2a" ;
		WHEN (x"96") => out_sbox:=x"90" ;
		WHEN (x"97") => out_sbox:=x"88" ;
		WHEN (x"98") => out_sbox:=x"46" ;
		WHEN (x"99") => out_sbox:=x"ee" ;
		WHEN (x"9a") => out_sbox:=x"b8" ;
		WHEN (x"9b") => out_sbox:=x"14" ;
		WHEN (x"9c") => out_sbox:=x"de" ;
		WHEN (x"9d") => out_sbox:=x"5e" ;
		WHEN (x"9e") => out_sbox:=x"0b" ;
		WHEN (x"9f") => out_sbox:=x"db" ;
		WHEN (x"a0") => out_sbox:=x"e0" ;
		WHEN (x"a1") => out_sbox:=x"32" ;
		WHEN (x"a2") => out_sbox:=x"3a" ;
		WHEN (x"a3") => out_sbox:=x"0a" ;
		WHEN (x"a4") => out_sbox:=x"49" ;
		WHEN (x"a5") => out_sbox:=x"06" ;
		WHEN (x"a6") => out_sbox:=x"24" ;
		WHEN (x"a7") => out_sbox:=x"5c" ;
		WHEN (x"a8") => out_sbox:=x"c2" ;
		WHEN (x"a9") => out_sbox:=x"d3" ;
		WHEN (x"aa") => out_sbox:=x"ac" ;
		WHEN (x"ab") => out_sbox:=x"62" ;
		WHEN (x"ac") => out_sbox:=x"91" ;
		WHEN (x"ad") => out_sbox:=x"95" ;
		WHEN (x"ae") => out_sbox:=x"e4" ;
		WHEN (x"af") => out_sbox:=x"79" ;
		WHEN (x"b0") => out_sbox:=x"e7" ;
		WHEN (x"b1") => out_sbox:=x"c8" ;
		WHEN (x"b2") => out_sbox:=x"37" ;
		WHEN (x"b3") => out_sbox:=x"6d" ;
		WHEN (x"b4") => out_sbox:=x"8d" ;
		WHEN (x"b5") => out_sbox:=x"d5" ;
		WHEN (x"b6") => out_sbox:=x"4e" ;
		WHEN (x"b7") => out_sbox:=x"a9" ;
		WHEN (x"b8") => out_sbox:=x"6c" ;
		WHEN (x"b9") => out_sbox:=x"56" ;
		WHEN (x"ba") => out_sbox:=x"f4" ;
		WHEN (x"bb") => out_sbox:=x"ea" ;
		WHEN (x"bc") => out_sbox:=x"65" ;
		WHEN (x"bd") => out_sbox:=x"7a" ;
		WHEN (x"be") => out_sbox:=x"ae" ;
		WHEN (x"bf") => out_sbox:=x"08" ;
		WHEN (x"c0") => out_sbox:=x"ba" ;
		WHEN (x"c1") => out_sbox:=x"78" ;
		WHEN (x"c2") => out_sbox:=x"25" ;
		WHEN (x"c3") => out_sbox:=x"2e" ;
		WHEN (x"c4") => out_sbox:=x"1c" ;
		WHEN (x"c5") => out_sbox:=x"a6" ;
		WHEN (x"c6") => out_sbox:=x"b4" ;
		WHEN (x"c7") => out_sbox:=x"c6" ;
		WHEN (x"c8") => out_sbox:=x"e8" ;
		WHEN (x"c9") => out_sbox:=x"dd" ;
		WHEN (x"ca") => out_sbox:=x"74" ;
		WHEN (x"cb") => out_sbox:=x"1f" ;
		WHEN (x"cc") => out_sbox:=x"4b" ;
		WHEN (x"cd") => out_sbox:=x"bd" ;
		WHEN (x"ce") => out_sbox:=x"8b" ;
		WHEN (x"cf") => out_sbox:=x"8a" ;
		WHEN (x"d0") => out_sbox:=x"70" ;
		WHEN (x"d1") => out_sbox:=x"3e" ;
		WHEN (x"d2") => out_sbox:=x"b5" ;
		WHEN (x"d3") => out_sbox:=x"66" ;
		WHEN (x"d4") => out_sbox:=x"48" ;
		WHEN (x"d5") => out_sbox:=x"03" ;
		WHEN (x"d6") => out_sbox:=x"f6" ;
		WHEN (x"d7") => out_sbox:=x"0e" ;
		WHEN (x"d8") => out_sbox:=x"61" ;
		WHEN (x"d9") => out_sbox:=x"35" ;
		WHEN (x"da") => out_sbox:=x"57" ;
		WHEN (x"db") => out_sbox:=x"b9" ;
		WHEN (x"dc") => out_sbox:=x"86" ;
		WHEN (x"dd") => out_sbox:=x"c1" ;
		WHEN (x"de") => out_sbox:=x"1d" ;
		WHEN (x"df") => out_sbox:=x"9e" ;
		WHEN (x"e0") => out_sbox:=x"e1" ;
		WHEN (x"e1") => out_sbox:=x"f8" ;
		WHEN (x"e2") => out_sbox:=x"98" ;
		WHEN (x"e3") => out_sbox:=x"11" ;
		WHEN (x"e4") => out_sbox:=x"69" ;
		WHEN (x"e5") => out_sbox:=x"d9" ;
		WHEN (x"e6") => out_sbox:=x"8e" ;
		WHEN (x"e7") => out_sbox:=x"94" ;
		WHEN (x"e8") => out_sbox:=x"9b" ;
		WHEN (x"e9") => out_sbox:=x"1e" ;
		WHEN (x"ea") => out_sbox:=x"87" ;
		WHEN (x"eb") => out_sbox:=x"e9" ;
		WHEN (x"ec") => out_sbox:=x"ce" ;
		WHEN (x"ed") => out_sbox:=x"55" ;
		WHEN (x"ee") => out_sbox:=x"28" ;
		WHEN (x"ef") => out_sbox:=x"df" ;
		WHEN (x"f0") => out_sbox:=x"8c" ;
		WHEN (x"f1") => out_sbox:=x"a1" ;
		WHEN (x"f2") => out_sbox:=x"89" ;
		WHEN (x"f3") => out_sbox:=x"0d" ;
		WHEN (x"f4") => out_sbox:=x"bf" ;
		WHEN (x"f5") => out_sbox:=x"e6" ;
		WHEN (x"f6") => out_sbox:=x"42" ;
		WHEN (x"f7") => out_sbox:=x"68" ;
		WHEN (x"f8") => out_sbox:=x"41" ;
		WHEN (x"f9") => out_sbox:=x"99" ;
		WHEN (x"fa") => out_sbox:=x"2d" ;
		WHEN (x"fb") => out_sbox:=x"0f" ;
		WHEN (x"fc") => out_sbox:=x"b0" ;
		WHEN (x"fd") => out_sbox:=x"54" ;
		WHEN (x"fe") => out_sbox:=x"bb" ;
		WHEN OTHERS => out_sbox:=x"16" ;
	END CASE;
	
		
END sbox;



procedure razvijanje (signal key_i:in std_logic_vector(127 downto 0);constant i:in integer;variable bafer_out: out std_logic_vector(127 downto 0)) is 
	variable bafer:std_logic_vector(127 downto 0);--signal koji se koristi u funkciji kao kljuc
	variable x1,x2,x3,x4:std_logic_vector(7 downto 0);--signali koje koristimo kao izlaz iz sbox
	variable kljuc_out:std_logic_vector(127 downto 0);
	variable broj:std_logic_vector(7 downto 0);--broj koji nam govori koji kljuc je upitanju
										 
begin
	
	bafer:=key_i;
	
	sbox(bafer(31 downto 24),x1); -- vrsimo rotaciju bitova i prolazak kroz sbox proceduru
	sbox(bafer(7 downto 0),x2);
	sbox(bafer(15 downto 8),x3);
	sbox(bafer(23 downto 16),x4);
			
	case (i) is    -- na osnovu konstante i odredjujemo sa kojom se vrednosti vrsi operacija xor nad brojem i x4
		when (1) => broj:=x"01";
		when (2) => broj:=x"02";
		when (3) => broj:=x"04";
		when (4) => broj:=x"08";
		when (5) => broj:=x"10";
		when (6) => broj:=x"20";
		when (7) => broj:=x"40";
		when (8) => broj:=x"80";
		when (9) => broj:=x"1b";
		when others => broj:=x"36";
	end case;
	
	x4:=broj xor x4;
		
			
	bafer(127 downto 120):=x4 xor bafer(127 downto 120);
	bafer(119 downto 112):=x3 xor bafer(119 downto 112);
	bafer(111 downto 104):=x2 xor bafer(111 downto 104);
	bafer(103 downto 96):=x1 xor bafer(103 downto 96);
	bafer(95 downto 88):=bafer(127 downto 120) xor bafer(95 downto 88);
	bafer(87 downto 80):=bafer(119 downto 112) xor bafer(87 downto 80);
	bafer(79 downto 72):=bafer(111 downto 104) xor bafer(79 downto 72);
	bafer(71 downto 64):=bafer(103 downto 96) xor bafer(71 downto 64);
	bafer(63 downto 56):=bafer(95 downto 88) xor bafer(63 downto 56);
	bafer(55 downto 48):=bafer(87 downto 80) xor bafer(55 downto 48);
	bafer(47 downto 40):=bafer(79 downto 72) xor bafer(47 downto 40);
	bafer(39 downto 32):=bafer(71 downto 64) xor bafer(39 downto 32);
	bafer(31 downto 24):=bafer(63 downto 56) xor bafer(31 downto 24);
	bafer(23 downto 16):=bafer(55 downto 48) xor bafer(23 downto 16);
	bafer(15 downto 8):=bafer(47 downto 40) xor bafer(15 downto 8);
	bafer(7 downto 0):=bafer(39 downto 32) xor bafer(7 downto 0);
			
	bafer_out:=bafer;
	
	
end razvijanje;



begin


	process (clk)
	
		variable kljuc1_int:std_logic_vector(127 downto 0):= (others => '0');
		variable kljuc2_int:std_logic_vector(127 downto 0):= (others => '0');
		variable kljuc3_int:std_logic_vector(127 downto 0):= (others => '0');
		variable kljuc4_int:std_logic_vector(127 downto 0):= (others => '0');
		variable kljuc5_int:std_logic_vector(127 downto 0):= (others => '0');
		variable kljuc6_int:std_logic_vector(127 downto 0):= (others => '0');
		variable kljuc7_int:std_logic_vector(127 downto 0):= (others => '0');
		variable kljuc8_int:std_logic_vector(127 downto 0):= (others => '0');
		variable kljuc9_int:std_logic_vector(127 downto 0):= (others => '0');
		variable kljuc10_int:std_logic_vector(127 downto 0):= (others => '0');

	begin
		
		if(clk' event and clk='1') then				
				--pocetna runda
				kljuc0_out<=kljuc; -- upisujemo kljuc u signal kljuc0
				kljuc1<=kljuc;-- upisujemo signal kljuc u interni signal kljuc0 koji se koristi u narednom taktu, ovo je upravo
										-- na koji nacin se realizuje tehnika pajplajn, da se svaka runda posebno implementira u hardveru
				--runda 1
				razvijanje(kljuc1,1,kljuc1_int); --poziv funkcije razvijanje u kojoj su argument prethodni kljuc
				kljuc1_out<=kljuc1_int;				--koji je broj kljuca koji hocemo da razvijemo i izlazni kljuc, zatim se ponovo vrsi 
				kljuc2<=kljuc1_int;					-- isti postupak kao u proslom delu koda
			
				--runda 2
				razvijanje(kljuc2,2,kljuc2_int);
				kljuc2_out<=kljuc2_int;
				kljuc3<=kljuc2_int;
				
				--runda 3
				razvijanje(kljuc3,3,kljuc3_int);
				kljuc3_out<=kljuc3_int;
				kljuc4<=kljuc3_int;
				
				--runda 4
				razvijanje(kljuc4,4,kljuc4_int);
				kljuc4_out<=kljuc4_int;
				kljuc5<=kljuc4_int;
				
				--runda 5
				razvijanje(kljuc5,5,kljuc5_int);
				kljuc5_out<=kljuc5_int;
				kljuc6<=kljuc5_int;
				
				--runda 6
				razvijanje(kljuc6,6,kljuc6_int);
				kljuc6_out<=kljuc6_int;
				kljuc7<=kljuc6_int;
				
				--runda 7
				razvijanje(kljuc7,7,kljuc7_int);
				kljuc7_out<=kljuc7_int;
				kljuc8<=kljuc7_int;
				
				--runda 8
				razvijanje(kljuc8,8,kljuc8_int);
				kljuc8_out<=kljuc8_int;
				kljuc9<=kljuc8_int;
				
				--runda 9
				razvijanje(kljuc9,9,kljuc9_int);
				kljuc9_out<=kljuc9_int;
				kljuc10<=kljuc9_int;
				
				--finalna runda
				razvijanje(kljuc10,10,kljuc10_int);
				kljuc10_out<=kljuc10_int;
				
		end if;--od clk	
	end process;
end shema;

